/***********************************************************************/
/*                                                                     */
/*  FILE        :resetprg.c                                            */
/*  DATE        :Wed, Nov 24, 2010                                     */
/*  DESCRIPTION :Reset Program                                         */
/*  CPU TYPE    :RX62N                                                 */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.51).    */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
/*********************************************************************
*
* Device     : RX/RX600
*
* File Name  : resetprg.c
*
* Abstract   : Reset Program, edited to include vector table definitions too.
*
* History    : 1.00  (2009-08-07)
*
* NOTE       : THIS IS A TYPICAL EXAMPLE.
*
* Copyright (C) 2009 Renesas Electronics Corporation.
* and Renesas Solutions Corporation. All rights reserved.
*
*********************************************************************/

#include	<machine.h>
#include	<_h_c_lib.h>
#include	"typedefine.h"
#include	"stacksct.h"
#include 	"vect.h"
#include 	"iodefine.h"

#pragma inline_asm Change_PSW_PM_to_UserMode

extern void PowerON_Reset_PC(void);
extern void main(void);
extern void _INIT_IOLIB(void);
extern void _CLOSEALL(void);
extern void HardwareSetup(void);

#define PSW_init  0x00010000
#define FPSW_init 0x00000100

/***********************************************************************
 * Program entry and initialisation point.
 ***********************************************************************/
#pragma section ResetPRG
#pragma entry PowerON_Reset_PC

void PowerON_Reset_PC(void)
{ 
	set_intb((unsigned long)__sectop("C$VECT"));
	set_fpsw(FPSW_init);

	_INITSCT();
	
	/* Use SIM I/O. */
	_INIT_IOLIB();					
	
	/* Set CPU PLL operating frequencies. Changes to the peripheral clock will 
	require	changes to the debugger and flash kernel BRR settings.
	Clockin = 12MHz, I Clock = 96MHz, B Clock = 24MHz, P Clock = 48MHz. */
	SYSTEM.SCKCR.LONG = 0x00020100;		
    nop();
	
	/* Set Ubit & Ibit for PSW. */
	set_psw(PSW_init);

	/* Call the application - would not expect to return from here. */
	main();

	/* Use SIM I/O */
	_CLOSEALL();		
	brk();
}



/***********************************************************************
 * Default functions to install in the vector table.
 ***********************************************************************/

#pragma section IntPRG

// Exception(Supervisor Instruction)
void Excep_SuperVisorInst(void){ brk(); }

// Exception(Undefined Instruction)
void Excep_UndefinedInst(void){ brk(); }

// Exception(Floating Point)
void Excep_FloatingPoint(void){ brk(); }

// NMI
void NonMaskableInterrupt(void){ brk(); }

// Dummy
void Dummy(void){ brk(); }




/***********************************************************************
 * Define the fixed vector table.
 ***********************************************************************/

#pragma section C FIXEDVECT

void* const Fixed_Vectors[] = {
//;0xffffffd0  Exception(Supervisor Instruction)
    (void*) Excep_SuperVisorInst,
//;0xffffffd4  Reserved
    Dummy,
//;0xffffffd8  Reserved
    Dummy,
//;0xffffffdc  Exception(Undefined Instruction)
    (void*) Excep_UndefinedInst,
//;0xffffffe0  Reserved
    Dummy,
//;0xffffffe4  Exception(Floating Point)
    (void*) Excep_FloatingPoint,
//;0xffffffe8  Reserved
    Dummy,
//;0xffffffec  Reserved
    Dummy,
//;0xfffffff0  Reserved
    Dummy,
//;0xfffffff4  Reserved
    Dummy,
//;0xfffffff8  NMI
    (void*) NonMaskableInterrupt,
//;0xfffffffc  RESET
//;<<VECTOR DATA START (POWER ON RESET)>>
//;Power On Reset PC
PowerON_Reset_PC                                                                                                                             
//;<<VECTOR DATA END (POWER ON RESET)>>
};




/***********************************************************************
 * Set up the B and R sections.
 ***********************************************************************/
#pragma unpack

#pragma section C C$DSEC
extern const struct {
    _UBYTE *rom_s;       /* Start address of the initialized data section in ROM */
    _UBYTE *rom_e;       /* End address of the initialized data section in ROM   */
    _UBYTE *ram_s;       /* Start address of the initialized data section in RAM */
}   _DTBL[] = {
    { __sectop("D"), __secend("D"), __sectop("R") },
    { __sectop("D_2"), __secend("D_2"), __sectop("R_2") },
    { __sectop("D_1"), __secend("D_1"), __sectop("R_1") }
};
#pragma section C C$BSEC
extern const struct {
    _UBYTE *b_s;         /* Start address of non-initialized data section */
    _UBYTE *b_e;         /* End address of non-initialized data section */
}   _BTBL[] = {
    { __sectop("B"), __secend("B") },
    { __sectop("B_2"), __secend("B_2") },
    { __sectop("B_1"), __secend("B_1") }
};

#pragma section

/*
** CTBL prevents excessive output of L1100 messages when linking.
** Even if CTBL is deleted, the operation of the program does not change.
*/
_UBYTE * const _CTBL[] = {
    __sectop("C_1"), __sectop("C_2"), __sectop("C"),
    __sectop("W_1"), __sectop("W_2"), __sectop("W")
};

#pragma packoption
